import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$1 } from './ic-typography2.js';

const icLoadingIndicatorCss = "/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */html{line-height:1.15;-webkit-text-size-adjust:100%;}body{margin:0}main{display:block}h1{font-size:2em;margin:0.67em 0}hr{box-sizing:content-box;height:0;overflow:visible;}pre{font-family:monospace, monospace;font-size:1em;}a{background-color:transparent}abbr[title]{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted;}b,strong{font-weight:bolder}code,kbd,samp{font-family:monospace, monospace;font-size:1em;}small{font-size:80%}sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}sub{bottom:-0.25em}sup{top:-0.5em}img{border-style:none}button,input,optgroup,select,textarea{font-family:inherit;font-size:100%;line-height:1.15;margin:0;}button,input{overflow:visible}button,select{text-transform:none}button,[type=\"button\"],[type=\"reset\"],[type=\"submit\"]{-webkit-appearance:button}button::-moz-focus-inner,[type=\"button\"]::-moz-focus-inner,[type=\"reset\"]::-moz-focus-inner,[type=\"submit\"]::-moz-focus-inner{border-style:none;padding:0}button:-moz-focusring,[type=\"button\"]:-moz-focusring,[type=\"reset\"]:-moz-focusring,[type=\"submit\"]:-moz-focusring{outline:1px dotted ButtonText}fieldset{padding:0.35em 0.75em 0.625em}legend{box-sizing:border-box;color:inherit;display:table;max-width:100%;padding:0;white-space:normal;}progress{vertical-align:baseline}textarea{overflow:auto}[type=\"checkbox\"],[type=\"radio\"]{box-sizing:border-box;padding:0;}[type=\"number\"]::-webkit-inner-spin-button,[type=\"number\"]::-webkit-outer-spin-button{height:auto}[type=\"search\"]{-webkit-appearance:textfield;outline-offset:-2px;}[type=\"search\"]::-webkit-search-decoration{-webkit-appearance:none}::-webkit-file-upload-button{-webkit-appearance:button;font:inherit;}details{display:block}summary{display:list-item}template{display:none}[hidden]{display:none}html,body,div,span,applet,object,iframe,h1,h2,h3,h4,h5,h6,p,blockquote,pre,a,abbr,acronym,address,big,cite,code,del,dfn,em,img,ins,kbd,q,s,samp,small,strike,strong,sub,sup,tt,var,b,u,i,center,dl,dt,dd,ol,ul,li,fieldset,form,label,legend,table,caption,tbody,tfoot,thead,tr,th,td,article,aside,canvas,details,embed,figure,figcaption,footer,header,hgroup,menu,nav,output,ruby,section,summary,time,mark,audio,video{margin:0;padding:0;border:0;font-size:100%;font-style:inherit;vertical-align:baseline}:host{display:block;--linear-border-radius:0.25rem;--inner-color:var(--ic-loading-indicator-inner-color);--outer-color:var(--ic-loading-indicator-outer-color);--label-color:var(--ic-loading-indicator-label-color);--margin:none;--linear-line-height:var(--ic-space-xs)}:host(.ic-loading-indicator-monochrome){--inner-color:var(--ic-loading-indicator-inner-color-monochrome);--outer-color:var(--ic-loading-indicator-outer-color-monochrome);--label-color:var(--ic-loading-indicator-label-color-monochrome)}.ic-loading-container{display:flex;flex-direction:column;justify-content:center;align-items:center}:host([size=\"small\"]){--circular-diameter:2.5rem;--linear-line-height:var(--ic-space-xxs)}:host([size=\"medium\"]){--circular-diameter:5rem}:host([size=\"large\"]){--circular-diameter:7.5rem}:host([size=\"icon\"]){display:inline-block;--margin:var(--ic-space-xxxs);--circular-diameter:1.25rem}:host(.ic-loading-indicator-label){--margin:0 0 var(--ic-space-xs) 0}.ic-loading-label{--ic-typography-color:var(--label-color);margin-left:var(--label-margin-left)}.ic-loading-circular-outer{height:var(--circular-diameter);width:var(--circular-diameter)}.ic-loading-circular-outer.indeterminate{animation:circular-animation 1s linear;animation-iteration-count:infinite}@keyframes circular-animation{100%{transform:rotate(360deg)}}.ic-loading-circular-outer,.ic-loading-linear-outer{margin:var(--margin)}.ic-loading-linear-outer{background-color:var(--outer-color);height:var(--linear-line-height);width:100%;border-radius:var(--linear-border-radius);overflow:hidden}.ic-loading-linear-inner{position:relative;height:100%;background-color:var(--inner-color);border-radius:var(--linear-border-radius)}.indeterminate>.ic-loading-linear-inner{animation:linear-animation 2s infinite}.determinate>.ic-loading-linear-inner{transition:width 0.5s;width:var(--linear-width)}:host(.ic-loading-indicator-full-width){--linear-border-radius:none}@keyframes linear-animation{0%{width:0%;left:-1%}25%{width:0%;left:-1%}50%{width:101%;left:-1%}75%{width:0%;left:101%}100%{width:0%;left:101%}}.ic-loading-circular-svg{position:relative;width:100%;height:100%;transform:rotate(-90deg)}.ic-loading-circular-svg circle{width:100%;height:100%;fill:none;stroke:var(--compact-step-outer-color, var(--outer-color));stroke-width:var(--circular-line-width);stroke-linecap:round}.ic-loading-circular-svg circle:nth-child(2){--circular-indeterminate:calc(\n    (0.25 * var(--stroke-dasharray)) - var(--stroke-dasharray)\n  );stroke-dasharray:var(--stroke-dasharray), var(--stroke-dasharray);stroke-dashoffset:var(--stroke-dashoffset, var(--circular-indeterminate));stroke:var(--compact-step-inner-color, var(--inner-color))}.inner-label{height:100%;display:grid}.inner-label .ic-loading-circular-svg,.inner-text{grid-column:1;grid-row:1}:host(.not-required.compact-step-progress-indicator) .ic-loading-circular-svg circle:nth-child(2){stroke:var(--ic-architectural-300)}.inner-text{display:flex;align-items:center;justify-content:center;width:var(--ic-space-lg);height:inherit;overflow:hidden;margin:auto;--ic-typography-color:var(\n    --ic-step-indicator-text-current,\n    var(--ic-status-info-default)\n  )}:host(.not-required.compact-step-progress-indicator) .inner-text{--ic-typography-color:var(--ic-step-indicator-text-disabled)}:host(.ic-loading-indicator-light.not-required.compact-step-progress-indicator) .inner-text{--ic-typography-color:var(--ic-architectural-400)}@media (forced-colors: active){.indeterminate>.ic-loading-circular-inner{forced-color-adjust:none}.ic-loading-linear-outer{border:var(--ic-border-hc)}.ic-loading-linear-inner{background-color:canvastext}.ic-loading-circular-svg circle{stroke:Background}.ic-loading-circular-svg circle:nth-child(2){stroke:canvastext}:host(.not-required.compact-step-progress-indicator) .ic-loading-circular-svg circle:nth-child(2){stroke:GrayText}}";
const IcLoadingIndicatorStyle0 = icLoadingIndicatorCss;

const LOADING_INDICATOR_WIDTHS = {
    large: 120,
    medium: 80,
    small: 40,
    icon: 20,
};
const LoadingIndicator = /*@__PURE__*/ proxyCustomElement(class LoadingIndicator extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.labelList = [];
        this.circularDiameter = 0;
        this.circularLineWidth = 0;
        this.circularDimensions = {
            x: 0,
            y: 0,
            r: 0,
        };
        this.clipInnerElement = false;
        /**
         * The description that will be set as the aria-label of the loading indicator when not using a visible label.
         */
        this.description = "Loading";
        /**
         * If `true`, when linear, the full-width variant (i.e. without a border radius) will be displayed.
         */
        this.fullWidth = false;
        /**
         * The time in milliseconds before the label changes.
         */
        this.labelDuration = 8000;
        /**
         * The maximum value that the progress value can take.
         * Used to calculate the proportional width of the progress bar.
         */
        this.max = 100;
        /**
         * The minimum value that the progress value can take.
         * Used to calculate the proportional width of the progress bar.
         */
        this.min = 0;
        /**
         * If `true`, the element will display as black and white.
         */
        this.monochrome = false;
        /**
         * The size of the loading indicator.
         */
        this.size = "medium";
        /**
         * Sets the theme color to the dark or light theme color. "inherit" will set the color based on the system settings or ic-theme component.
         */
        this.theme = "inherit";
        /**
         * The type of indicator, either linear or circular.
         */
        this.type = "circular";
        this.getLabel = (labelIndex) => new Promise(() => {
            this.interval = setInterval(() => {
                if (labelIndex < this.labelList.length - 1) {
                    labelIndex++;
                }
                else {
                    labelIndex = 0;
                }
                this.indicatorLabel = this.labelList[labelIndex];
            }, this.labelDuration);
        });
        this.getLabelVariant = () => {
            const width = this.type === "circular" ? this.calculateWidth() : 0;
            if (this.size === "small" || (width && width < 60)) {
                return "label";
            }
            else if (this.size === "large" || width >= 120) {
                return "h2";
            }
            return "h4";
        };
        this.calculateWidth = () => {
            var _a, _b, _c;
            if ((_a = this.outerElement) === null || _a === void 0 ? void 0 : _a.offsetWidth)
                return this.outerElement.offsetWidth;
            if (this.outerElement) {
                const { width } = window.getComputedStyle(this.outerElement);
                if (width) {
                    // Regex to check the units of the css string
                    if (((_b = width.match(/\D+$/)) === null || _b === void 0 ? void 0 : _b[0]) !== "%")
                        return parseFloat(width);
                    const parentWidth = (_c = this.outerElement.parentElement) === null || _c === void 0 ? void 0 : _c.offsetWidth;
                    if (parentWidth)
                        return parentWidth * (parseFloat(width) / 100);
                }
            }
            return LOADING_INDICATOR_WIDTHS[this.size];
        };
        this.setLinearDeterminateWidth = () => {
            // Ensure progress cannot be out of bounds
            if (!this.innerElement || !this.progress)
                return;
            const progress = Math.min(this.max, Math.max(this.min, this.progress));
            const proportion = (progress - this.min) / (this.max - this.min);
            this.clipInnerElement = proportion > 0.5;
            if (this.clipInnerElement) {
                this.innerElement.classList.remove("clip");
            }
            else {
                this.innerElement.classList.add("clip");
            }
            this.innerElement.style.setProperty("--linear-width", `${proportion * 100}%`);
        };
        this.updateLabel = () => {
            if (!this.label)
                return;
            if (typeof this.label === "string") {
                this.indicatorLabel = this.label;
            }
            else {
                this.labelList = this.label;
                this.indicatorLabel = this.labelList[0];
                if (this.labelList.length > 1) {
                    this.getLabel(0);
                }
            }
        };
        this.setCircleDimensions = () => {
            let dashOffset = undefined;
            if (this.circularDiameter <= 0)
                return;
            const r = this.circularDiameter / 2;
            const nextRadius = r - this.circularLineWidth / 2;
            const dashArray = 2 * Math.PI * nextRadius;
            if (this.progress) {
                const progress = Math.min(Math.max(this.progress, this.min), this.max);
                dashOffset = `${(-1 - (progress - this.min) / (this.max - this.min)) * dashArray}px`;
            }
            this.circularDimensions = {
                x: r,
                y: r,
                r: nextRadius,
                dashArray: `${dashArray}px`,
                dashOffset,
            };
        };
    }
    watchPropHandler() {
        this.updateLabel();
    }
    minMaxChangeHandler() {
        if (this.type === "circular")
            this.setCircleDimensions();
    }
    watchProgressHandler() {
        if (this.type === "linear") {
            this.setLinearDeterminateWidth();
        }
        else {
            this.setCircleDimensions();
        }
    }
    setIndicatorDimensions() {
        if (this.type === "circular") {
            // Sets the circular indicator line width - accounting for the circle size being altered using the CSS custom property
            const diameter = this.calculateWidth();
            if (this.outerElement && diameter !== this.circularDiameter) {
                this.circularLineWidth = diameter * 0.1;
                this.circularDiameter = diameter;
                this.outerElement.style.setProperty("--circular-line-width", `${this.circularLineWidth}px`);
                this.setCircleDimensions();
            }
        }
        else {
            this.setLinearDeterminateWidth();
        }
    }
    disconnectedCallback() {
        clearInterval(this.interval);
    }
    componentWillLoad() {
        this.updateLabel();
        this.el.setAttribute("exportparts", "ic-loading-container");
    }
    componentDidLoad() {
        this.setIndicatorDimensions();
    }
    render() {
        const { theme, label, description, size, fullWidth, innerLabel, monochrome, type, progress, min, max, circularDiameter, indicatorLabel, circularDimensions, } = this;
        const { x, y, r, dashArray, dashOffset } = circularDimensions;
        return (h(Host, { key: '7f78047511c580f116c21d00e76a19dee3319d60', class: {
                [`ic-theme-${theme}`]: theme !== "inherit",
                "ic-loading-indicator-full-width": fullWidth,
                "ic-loading-indicator-label": !!label,
                "ic-loading-indicator-monochrome": monochrome,
            } }, h("div", { key: 'eec896daa35399c26a11873674ba4bc4fd099ddc', class: "ic-loading-container", part: "ic-loading-container" }, h("div", { key: 'b3ab1935e9fe5d50cd6513acd7a8eabb31fadf98', ref: (el) => (this.outerElement = el), class: {
                [`ic-loading-${type}-outer`]: true,
                [progress === undefined ? "indeterminate" : "determinate"]: true,
            }, role: "progressbar", "aria-labelledby": label && size !== "icon" && "ic-loading-label", "aria-label": description, "aria-valuenow": progress, "aria-valuemin": min, "aria-valuemax": max }, h("div", { key: '2f6e1f2e1a88b752cdda2a6b2834441e8546eb9b', ref: (el) => (this.innerElement = el), class: {
                [`ic-loading-${type}-inner`]: true,
                "inner-label": !!innerLabel,
            } }, innerLabel && size === "small" && (h("ic-typography", { key: 'c0d18d282c7090aa2bf478c3beee03e6c2b2f61d', variant: "subtitle-small", class: "inner-text" }, innerLabel)), type === "circular" && (h("svg", { key: 'a5827dba8cff99684667dfa1147186ad0bd3f7a1', class: "ic-loading-circular-svg", viewBox: `0 0 ${circularDiameter} ${circularDiameter}` }, h("circle", { key: 'c53d2155e9aea468427178f5a41e0a24b02565fa', cx: x, cy: y, r: r }), h("circle", { key: 'c5b6aea5b936b056a8103c0dacb81822348b20d1', style: {
                "--circular-steps-max": progress ? `${max}` : undefined,
                "--progress-value": progress !== undefined ? `${progress}` : undefined,
                "--stroke-dasharray": dashArray,
                "--stroke-dashoffset": dashOffset,
            }, cx: x, cy: y, r: r }))))), label && size !== "icon" && (h("ic-typography", { key: 'e586d3c31d518a77bf93f90504318e3a5baeeb64', id: "ic-loading-label", class: "ic-loading-label", role: "status", variant: this.getLabelVariant() }, h("p", { key: 'd1c0b977ef4441ae45f4122a7a0ee03b33b4421b' }, indicatorLabel))))));
    }
    get el() { return this; }
    static get watchers() { return {
        "label": ["watchPropHandler"],
        "max": ["minMaxChangeHandler"],
        "min": ["minMaxChangeHandler"],
        "progress": ["watchProgressHandler"],
        "type": ["setIndicatorDimensions"]
    }; }
    static get style() { return IcLoadingIndicatorStyle0; }
}, [1, "ic-loading-indicator", {
        "description": [1],
        "fullWidth": [516, "full-width"],
        "innerLabel": [2, "inner-label"],
        "label": [1],
        "labelDuration": [2, "label-duration"],
        "max": [2],
        "min": [2],
        "monochrome": [4],
        "progress": [2],
        "size": [513],
        "theme": [1],
        "type": [513],
        "circularDiameter": [32],
        "circularLineWidth": [32],
        "circularDimensions": [32],
        "indicatorLabel": [32],
        "clipInnerElement": [32]
    }, undefined, {
        "label": ["watchPropHandler"],
        "max": ["minMaxChangeHandler"],
        "min": ["minMaxChangeHandler"],
        "progress": ["watchProgressHandler"],
        "type": ["setIndicatorDimensions"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["ic-loading-indicator", "ic-typography"];
    components.forEach(tagName => { switch (tagName) {
        case "ic-loading-indicator":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, LoadingIndicator);
            }
            break;
        case "ic-typography":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { LoadingIndicator as L, defineCustomElement as d };

//# sourceMappingURL=ic-loading-indicator2.js.map